***New mod for Counter-Strike based on SuperHero Mod <https://github.com/ibiruai/cstrike-skills>***

## About

I was editing SuperHero Mod plugin, its heroes, and porting new heroes from other plugins for my Counter-Strike 1.6 server. This repository helped me track my edits.

Things I did

- [x] SuperHero Mod and heroes translated in Russian
- [x] Players see information about their cooldowns
- [x] Bots can use some active powers
- [x] User-friendly SuperHero Mod menu and help page with heroes' details
- [x] Ported heroes no other SuperHero Mod server has yet
- [x] Scorpion doesn't hold a target forever, no footsteps with Shift pressed, and minor things like that

Website: <https://ibiruai.github.io/cstrike-superhero-server/>

Send `amx_helpfile` to game server console to generate help pages and docs/index.html

## What does someone need to run a Counter-Strike 1.6 server with plugins

1. [The Steam Console Client or SteamCMD][SteamCMD] is a command-line version of the Steam client. It allows to install and update a dedicated server using a command-line interface.

2. [The Half-Life Dedicated Server or HLDS][HLDS] is an application to run a dedicated server for GoldSrc games. [How to download HLDS using SteamCMD](https://developer.valvesoftware.com/wiki/SteamCMD#Downloading_an_app).

3. [Metamod] is a plugin/DLL manager that sits between the Half-Life Engine and an HL Game mod, allowing the dynamic loading/unloading of mod-like DLL plugins to add functionality to the HL server or game mod.

4. [AMX Mod X] is a Metamod plugin for Half-Life. People write AMX Mod X plugins using a scripting language called Pawn to add administrative services, statistics generation, gameplay changes (WC3, CSDM, SuperHero Mod), and other things.

5. AMX Mod X plugins. Since you are probably interested in SuperHero Mod, you might want to check [its subforum on Alliedmods.net](https://forums.alliedmods.net/forumdisplay.php?f=30).
[How to compile AMX Mod X plugins](https://wiki.alliedmods.net/Compiling_Plugins_(AMX_Mod_X)).

6. Maps, sounds, models and other files should be available via FastDL or people won't join the server.

[SteamCMD]: https://developer.valvesoftware.com/wiki/SteamCMD

[HLDS]:  https://developer.valvesoftware.com/wiki/Half-Life_Dedicated_Server

[Metamod]: http://metamod.org

[AMX Mod X]: https://www.amxmodx.org

## List of AMX Mod X plugins used on the server

[SuperHero Mod](https://forums.alliedmods.net/showthread.php?t=76081),
[Weapons MaxSpeed](https://forums.alliedmods.net/showthread.php?t=139521),
[Galileo](https://forums.alliedmods.net/showthread.php?t=77391),
[Reset Score](https://forums.alliedmods.net/showthread.php?t=74207),
[CS AFK Manager](https://forums.alliedmods.net/showthread.php?t=256449),
[SuperHero Monitor](https://forums.alliedmods.net/showthread.php?t=36540),
[WalkGuard](https://forums.alliedmods.net/showthread.php?t=55245),
[Colored Translit](https://c-s.net.ua/forum/topic25056.html),
[Ptahhotep's Team Balancer](https://forums.alliedmods.net/showthread.php?t=26598),
[LongJump Enabler](https://forums.alliedmods.net/showthread.php?t=108382),
[Anti-ChatSpam](https://forums.alliedmods.net/showthread.php?t=90414),
[Sentry Guns](https://forums.alliedmods.net/showthread.php?t=78632),
[One Name](https://forums.alliedmods.net/showpost.php?p=1552827&postcount=3),
[Map specific commands](https://forums.alliedmods.net/showthread.php?t=16517),
[Vote Ban](https://forums.alliedmods.net/showthread.php?t=96586),
[Bunny Hop Abilities](https://forums.alliedmods.net/showthread.php?t=69840),
[Force Round End](https://forums.alliedmods.net/showthread.php?t=56941),
No footsteps while walking, Hints, Bot Manager

**Heroes**

[Heroes included in SuperHero Mod](https://forums.alliedmods.net/showthread.php?t=76081),
[Alien](https://forums.alliedmods.net/showthread.php?t=30082),
[Bass](https://forums.alliedmods.net/showthread.php?t=30174),
[Bishop](https://forums.alliedmods.net/showthread.php?t=30184),
[Domino](https://forums.alliedmods.net/showthread.php?t=36055),
[Explosion](https://forums.alliedmods.net/showthread.php?t=34294),
[Mirage](https://forums.alliedmods.net/showthread.php?t=34683),
[Phoenix](https://forums.alliedmods.net/showthread.php?t=30270),
[Poison Ivy](https://forums.alliedmods.net/showthread.php?t=30104),
[Psylocke](https://forums.alliedmods.net/showthread.php?t=30276),
[Punisher V2](https://forums.alliedmods.net/showthread.php?t=131398),
[Scorpion](https://forums.alliedmods.net/showthread.php?t=34448),
[Snake](https://forums.alliedmods.net/showthread.php?t=30293),
[The Tick](https://forums.alliedmods.net/showthread.php?t=36058),
[Thing](https://forums.alliedmods.net/showthread.php?t=31929),
[Mario](https://forums.alliedmods.net/showthread.php?t=32041),
[Catwoman](https://forums.alliedmods.net/showthread.php?t=34742),
[Electro](https://forums.alliedmods.net/showthread.php?t=30095),
[Jubilee](https://forums.alliedmods.net/showthread.php?t=30592),
[Bazooka](https://forums.alliedmods.net/showthread.php?t=30087)

**Ported heroes**

[Orc](https://forums.alliedmods.net/showthread.php?t=314199) (Equipment Reincarnation from [Warcraft3 XP](https://forums.alliedmods.net/showthread.php?t=15345)),
Blink (Teleport from [Warcraft 3 Frozen Throne](https://forums.alliedmods.net/showthread.php?p=3158)),
Cho'Gath,
Freeman (there was already [Frogger](https://forums.alliedmods.net/showthread.php?t=33644) but I didn't notice it),
Bomberman V2,
Janna (Healing totem from [Diablo Mod](https://github.com/hitmany/cs-1.6-diablo-2)),
Chell ([Portal Gun](https://next21.ru/2013/04/%D0%BF%D0%BB%D0%B0%D0%B3%D0%B8%D0%BD-portal-gun/))

Check descriptions of the heroes on the website: <https://ibiruai.github.io/cstrike-superhero-server/>
