#!/bin/bash
# This script launches HLDS and checks periodically if HLDS is OK.
# It works in pair with restart_me.amxx.
#
# I added these to my crontab:
# @reboot ~/check-hlds.sh >> ~/Half-Life/cstrike/addons/amxmodx/logs/restart_me.log
# */5 * * * * ~/check-hlds.sh >> ~/Half-Life/cstrike/addons/amxmodx/logs/restart_me.log

cd ~/Half-Life # Half-Life folder
port=27015
screen_name=hlds # "apt install screen" to install screen. Use "screen -x hlds" later.
restart_me_log="cstrike/addons/amxmodx/logs/restart_me.log" # File generated by restart_me.amxx.
start_hlds () {
	screen -AmdS $screen_name ./hlds_run -console -game cstrike +map de_dust2 +maxplayers 24 +port $port -pingboost 3 -autoupdate -insecure
}
if [ `lsof -i | grep $port | wc -m` = 0 ] # Nothing is listening on the port. HLDS not started.
then
	echo
	echo `date` Starting HLDS.
	start_hlds
else
	if [ $((`date +%s` - `stat -c %Y $restart_me_log`)) -gt 180 ]
	then
		sleep 20
		if [ $((`date +%s` - `stat -c %Y $restart_me_log`)) -gt 180 ] # HLDS froze, or restart_me.amxx is not running.
		then
			screen -X -S @screen_name kill
			echo
			echo `date` HLDS is frozen. Restarting HLDS.
			start_hlds
		fi
	fi
fi
