// CAPTAIN AMERICA!

/* CVARS - copy and paste to shconfig.cfg

//Captain America
captaina_level 0
captaina_percent 0.05		//Percentage that factors into godmode randomness (Default 0.05)
captaina_godsecs 1.0		//# of seconds of god mode

*/

// 21 dec 2018 - Evileye - Your level doesn't matter anymore. It works the same for players of different levels.

//---------- User Changeable Defines --------//


// 0 = better chance the higher your level, 1 = chance is always the same
#define NO_ADVANTAGE_PER_LEVEL 1


//------- Do not edit below this point ------//

#include <superheromod>

// GLOBAL VARIABLES
new gHeroID
new const gHeroName[] = "Captain America"
new bool:gHasCaptainAmerica[SH_MAXSLOTS+1]
new gPcvarPercent, gPcvarGodSecs
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Captain America", SH_VERSION_STR, "{HOJ} Batman/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	new pcvarLevel = register_cvar("captaina_level", "0")
	gPcvarPercent = register_cvar("captaina_percent", "0.05")
	gPcvarGodSecs = register_cvar("captaina_godsecs", "1.0")

	// FIRE THE EVENTS TO CREATE THIS SUPERHERO!
	gHeroID = sh_create_hero(gHeroName, pcvarLevel)
	
	#if NO_ADVANTAGE_PER_LEVEL
		sh_set_hero_info(gHeroID, "Super Shield", "Random Invincibility")
	#else
		sh_set_hero_info(gHeroID, "Super Shield", "Random Invincibility, better chance the higher your level")
	#endif

	// OK Random Generator
	set_task(1.0, "captaina_loop", _, _, _, "b")
}
//----------------------------------------------------------------------------------------------
#if !NO_ADVANTAGE_PER_LEVEL
public plugin_cfg()
{
	// Check here so sh_get_num_lvls has time to set itself
	gMaxLevelFactor = (10.0 / sh_get_num_lvls()) * 100.0
}
#endif
//----------------------------------------------------------------------------------------------			
public sh_hero_init(id, heroID, mode)
{
	if ( gHeroID != heroID ) return

	gHasCaptainAmerica[id] = mode ? true : false

	sh_debug_message(id, 1, "%s %s", gHeroName, mode ? "ADDED" : "DROPPED")
}
//----------------------------------------------------------------------------------------------
public captaina_loop()
{
	if ( !sh_is_active() ) return

	static Float:percent
	static Float:godsecs
	percent = get_pcvar_float(gPcvarPercent)
	godsecs = get_pcvar_float(gPcvarGodSecs)
	#if !NO_ADVANTAGE_PER_LEVEL
		static heroLevel
	#endif

	static players[32], playerCount, id, i
	get_players(players, playerCount, "ah")

	for ( i = 0; i < playerCount; i++ ) {
		id = players[i]

		if ( gHasCaptainAmerica[id] && !get_user_godmode(id) ) {

		#if NO_ADVANTAGE_PER_LEVEL
			if ( percent * 100 >= random_num(0, 100) ) {
		#else
			heroLevel = floatround(sh_get_user_lvl(id) * pctperlev * gMaxLevelFactor)
			if ( heroLevel >= random_num(0, 100) ) {
		#endif
		
				sh_set_godmode(id, godsecs)

				//Quick Blue Screen Flash Letting You know about god mode
				sh_screen_fade(id, godsecs, godsecs/2, 0, 0, 255, 50, SH_FFADE_MODULATE)
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	gHasCaptainAmerica[id] = false
}
//----------------------------------------------------------------------------------------------