// CHO'GATH! - The Terror of the Void

/* CVARS - copy and paste to shconfig.cfg

//Cho'Gath
chogath_level 8
chogath_hpgain 8
chogath_maxextrahp 125

*/

#define SHMOD_EDIT 1

#include <amxmodx>
#include <superheromod>
#include <fvault>

// GLOBAL VARIABLES
new gHeroID
new gHeroName[] = "Cho'Gath"
new bool:gHasChogath[SH_MAXSLOTS+1]
new gExtraHP[SH_MAXSLOTS+1]
new gStacks[SH_MAXSLOTS+1]
new const gChogatSound[] = "shmod/chogath_feast.wav"
#if SHMOD_EDIT
//new gMaxHealth[SH_MAXSLOTS+1]
#endif
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Cho'Gath", "1.0", "Evileye")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	new pcvarLevel = register_cvar("chogath_level", "8")
	register_cvar("chogath_hpgain", "8")
	register_cvar("chogath_maxextrahp", "125")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	gHeroID = sh_create_hero(gHeroName, pcvarLevel)
	sh_set_hero_info(gHeroID, "Feast", "Get Extra HP by killing enemies with a knife")
	
	// NEW SPAWN
	register_event("ResetHUD", "newSpawn", "b")
	
	// DEATH
	register_event("DeathMsg", "chogath_death", "a")
	
	#if SHMOD_EDIT
	// CHECK LOOP
	set_task(2.0, "chogath_loop", _, _, _, "b")
	#endif
	
	// PLAYERS WILL LOOSE SOME HPs WHEN DROPPED
	register_cvar("chogath_health", "125")
	shSetMaxHealth(gHeroName, "chogath_health")
	
	// GAME RESTART
	register_event("TextMsg", "event_game_restart", "a", "2=#Game_Commencing", "2=#Game_will_restart_in")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	precache_sound(gChogatSound)
}
//----------------------------------------------------------------------------------------------
public event_game_restart()
{
	for (new id = 1; id <= SH_MAXSLOTS; id++)
		gExtraHP[id] = 0
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( gHeroID != heroID ) return

	gHasChogath[id] = mode ? true : false

	sh_debug_message(id, 1, "%s %s", gHeroName, mode ? "ADDED" : "DROPPED")
	
	/*
	if ( gHasChogath[id] )
		chogath_change_max_hp(id, gMaxHealth[id] + gExtraHP[id])
	else
		chogath_change_max_hp(id, gMaxHealth[id])
	*/
}
//----------------------------------------------------------------------------------------------
public newSpawn(id)
{
	if ( !sh_is_active() ) return
	if ( !gHasChogath[id] || !gExtraHP[id] ) return
	
	new array[3]
	array[0] = id
	array[1] = gExtraHP[id]
	#if SHMOD_EDIT
	array[2] = 0
	#endif
	set_task(1.2, "chogath_healthOnSpawn", 857391, array, sizeof(array))
	
	#if SHMOD_EDIT
	array[2] = 1
	set_task(4.0, "chogath_healthOnSpawn", 857392, array, sizeof(array))
	#endif
}
//----------------------------------------------------------------------------------------------
public chogath_healthOnSpawn(array[])
{
	new id = array[0]
	
	if (!is_user_connected(id)) return
	
	new hitPoints = array[1]
	#if SHMOD_EDIT
	if (!array[2])
	{
		//gMaxHealth[id] = sh_get_max_hp(id)
		chogath_change_max_hp(id, /*gMaxHealth[id]*/ get_cvar_num("sh_defaulthealth") + hitPoints)
		sh_add_hp( id, hitPoints )
	}
	else
		chogath_change_max_hp(id, /*gMaxHealth[id]*/ get_cvar_num("sh_defaulthealth") + hitPoints)
	#else
	sh_add_hp( id, hitPoints, sh_get_max_hp(id) + get_cvar_num("chogath_maxextrahp") )
	#endif
}
//----------------------------------------------------------------------------------------------
public chogath_death()
{
	if ( !sh_is_active() ) return
	new attacker = read_data(1)
	new victim = read_data(2)
	new WeaponName[20]
	read_data(4, WeaponName, 19)
	
	if ( !gHasChogath[attacker] || !equali(WeaponName, "knife") || attacker == victim ) return
	
	new attackerName[33], victimName[33]	
	get_user_name(attacker, attackerName, 32)
	get_user_name(victim, victimName, 32)
	
	new maxextrahp = get_cvar_num("chogath_maxextrahp")
	new hp_gain = get_cvar_num("chogath_hpgain")

	gStacks[attacker]++
	
	if ( gExtraHP[attacker] + hp_gain > maxextrahp )
		hp_gain = maxextrahp - gExtraHP[attacker]
	if ( hp_gain > 0 )
	{
		gExtraHP[attacker] += hp_gain
		for ( new i = 1; i <= SH_MAXSLOTS; i++ )
			if ( is_user_connected(i) )
				sh_chat_message(i, gHeroID, "%L", i, "CHOGATH_FEAST", attackerName, victimName, hp_gain)
		#if SHMOD_EDIT
		chogath_change_max_hp(attacker, /*gMaxHealth[id]*/get_cvar_num("sh_defaulthealth") + gExtraHP[attacker])
		#endif
	} else
		for ( new i = 1; i <= SH_MAXSLOTS; i++ )
			if ( is_user_connected(i) )
				sh_chat_message(i, gHeroID, "%L", i, "CHOGATH_FEAST_MAX", attackerName, victimName) 
	#if SHMOD_EDIT
	sh_add_hp( attacker, hp_gain )
	#else
	sh_add_hp( attacker, hp_gain, sh_get_max_hp(attacker) + maxextrahp )
	#endif
	
	emit_sound(attacker, CHAN_AUTO, gChogatSound, VOL_NORM, ATTN_NORM, 0, PITCH_LOW)
}
//----------------------------------------------------------------------------------------------
public client_connected(id)
{
	gStacks[id] = 0
	gExtraHP[id] = 0
}
//----------------------------------------------------------------------------------------------
public client_disconnected(id)
{
	if ( gStacks[id] > 0 )
	{
		new playername[33], string[16]
		get_user_name(id, playername, 32)
		if ( fvault_get_data("vault_chogath", playername, string, 15) )
		{
			gStacks[id] += str_to_num(string)
		}
		format(string, 15, "%d", gStacks[id])
		fvault_pset_data("vault_chogath", playername, string)
	}
	
	gStacks[id] = 0
	gExtraHP[id] = 0
}
//----------------------------------------------------------------------------------------------
#if SHMOD_EDIT
public chogath_change_max_hp(id, hitPoints)
{
	if ( callfunc_begin("sh_change_max_hp", "superheromodnvault.amxx") == 1 ) 
	{
		callfunc_push_int(id)
		callfunc_push_int(hitPoints)
		callfunc_end()
	}
}
//----------------------------------------------------------------------------------------------
public chogath_loop()
{
	if ( !sh_is_active() ) return

	static players[SH_MAXSLOTS], playerCount, id, i
	get_players(players, playerCount, "ah")

	for ( i = 0; i < playerCount; i++ ) {
		id = players[i]

		if ( gHasChogath[id] && sh_get_max_hp(id) != get_cvar_num("sh_defaulthealth") + gExtraHP[id] ) {
			chogath_change_max_hp(id, /*gMaxHealth[id]*/get_cvar_num("sh_defaulthealth") + gExtraHP[id])
		}
	}
}
//----------------------------------------------------------------------------------------------
#endif


/* * superheromodnvault.sma *
public sh_change_max_hp(id, hitPoints)
{
	//stupid check - but checking prevents crashes
	if ( id < 1 || id > gServersMaxPlayers ) return

	gMaxHealth[id] += hitPoints
}
*/