// DOMINO! from marvel comics. Has probability-altering field which allows things to fall into place for her.

/* CVARS - copy and paste to shconfig.cfg

//Domino
domino_level 0
domino_maxmult 2.0		//Max possible damage multiplier, range 1.01 to 2.0 (Default 2.0)

*/

/*
* v1.3 - vittu - 9/21/09
*      - Updated to SH 1.20.
*
* v1.2 - vittu - 1/27/07
*      - Small fix to make sure weapon is a gun.
*
* v1.1 - vittu - 7/18/06
*      - Small code changes, updated to amxmodx 1.70 and above.
*
*/

#include <superheromod>

// GLOBAL VARIABLES
new gHeroID
new bool:HasDomio[SH_MAXSLOTS+1]
new gPcvarMaxMult
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Domino", "1.3", "vittu")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	new pcvarLevel = register_cvar("domino_level", "0")
	gPcvarMaxMult = register_cvar("domino_maxmult", "2.0")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	gHeroID = sh_create_hero("Domino", pcvarLevel)
	sh_set_hero_info(gHeroID, "Even the Odds", "Do more Gun Damage to Higher Levels, the larger the difference the more damage.")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( gHeroID != heroID ) return

	HasDomio[id] = mode ? true : false
}
//----------------------------------------------------------------------------------------------
public client_damage(attacker, victim, damage, wpnindex, hitplace)
{
	if ( !sh_is_active() ) return
	if ( !is_user_alive(victim) || !is_user_connected(attacker) ) return
	if ( !HasDomio[attacker] ) return

	new slot = sh_get_weapon_slot(wpnindex)

	if ( slot == 1 || slot == 2 )
	{
		new victimLevel = sh_get_user_lvl(victim)
		new attackerLevel = sh_get_user_lvl(attacker)

		if ( victimLevel > attackerLevel )
		{
			new weaponName[32]
			new headshot = hitplace == 1 ? 1 : 0

			// Multiplier can not exceed 1.999999999... by this calculation. Not possible to devide by 0 because of above check
			new Float:multiplier = ( float(victimLevel - attackerLevel) / float(victimLevel) ) + 1.0
			new Float:maxMult = get_pcvar_float(gPcvarMaxMult)

			// Check to see if server set a max value possible
			if ( multiplier > maxMult )
			{
				multiplier = maxMult
			}

			get_weaponname(wpnindex, weaponName, 31)
			replace(weaponName, 31, "weapon_", "")

			// Do extra damage
			new extraDamage = floatround(damage * multiplier - damage)
			if ( extraDamage > 0 )
			{
				sh_extra_damage(victim, attacker, extraDamage, weaponName, headshot)
			}
		}
	}
}
//----------------------------------------------------------------------------------------------