// GORDON FREEMAN!
// LongJump Enabler plugin is required. https://forums.alliedmods.net/showthread.php?p=980939
// Crowbar code was borrowed from FreemanMod by Pro Patria Finland.
// You can find it here: https://forums.alliedmods.net/showthread.php?t=56155

/* CVARS - copy and paste to shconfig.cfg

//Freeman
freeman_level 0
freeman_longjump 1

*/

#include <superheromod>
#include <fakemeta>
#include <fun>

// GLOBAL VARIABLES
new gHeroID
new const gHeroName[] = "Freeman"
new bool:gHasFreemanPower[SH_MAXSLOTS+1]
new isFreezeTime = false
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Freeman", "1.0", "Evileye")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	new pcvarLevel = register_cvar("freeman_level", "0")
	register_cvar("freeman_longjump", "1")

	// FIRE THE EVENTS TO CREATE THIS SUPERHERO!
	gHeroID = sh_create_hero(gHeroName, pcvarLevel)
	sh_set_hero_info(gHeroID, "Long Jump Module", "Get Crowbar and Long Jump Module")
	
	register_event("CurWeapon", "giveCrowbar", "be", "1=1")
	register_forward(FM_EmitSound, "fw_emitsound")
	register_event("HLTV", "@event_hltv", "a", "1=0", "2=0")
	register_logevent("@round_start", 2, "1=Round_Start")
}
//----------------------------------------------------------------------------------------------
@event_hltv() {
	isFreezeTime = true
}
//----------------------------------------------------------------------------------------------
@round_start() {
	isFreezeTime = false
	if ( !sh_is_active() || !get_cvar_num("freeman_longjump") ) return

	static players[SH_MAXSLOTS], playerCount, player, i
	get_players(players, playerCount, "ah")

	for ( i = 0; i < playerCount; i++ ) {
		player = players[i]

		if ( gHasFreemanPower[player] ) {
			give_item(player, "item_longjump")
		}
	}
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( gHeroID != heroID ) return

	switch(mode) {
		case SH_HERO_ADD: {
			gHasFreemanPower[id] = true
			if ( !isFreezeTime && get_cvar_num("freeman_longjump") )
				give_item(id, "item_longjump")
			giveCrowbar(id)
		}
		case SH_HERO_DROP: {
			gHasFreemanPower[id] = false
			removeCrowbar(id)
		}
	}
	
	sh_debug_message(id, 1, "%s %s", gHeroName, mode ? "ADDED" : "DROPPED")
}
//----------------------------------------------------------------------------------------------
public plugin_precache() {
	precache_model("models/p_crowbar.mdl")
	precache_model("models/v_crowbar.mdl")
	precache_sound("weapons/cbar_hit1.wav")
	precache_sound("weapons/cbar_hitbod1.wav")
	precache_sound("weapons/cbar_hitbod2.wav")
	precache_sound("weapons/cbar_hitbod3.wav")
	precache_sound("weapons/cbar_miss1.wav")
}
//----------------------------------------------------------------------------------------------
public sh_client_spawn(id)
{
	if ( !isFreezeTime && sh_is_active() && get_cvar_num("freeman_longjump") && gHasFreemanPower[id] )
		give_item(id, "item_longjump")
}
//----------------------------------------------------------------------------------------------
public giveCrowbar(id) {
	if (  !is_user_alive(id) || !gHasFreemanPower[id] )
		return PLUGIN_CONTINUE

	new szWeapon[128]
	pev(id, pev_viewmodel2, szWeapon, charsmax(szWeapon))  
	if (!equali(szWeapon, "models/v_knife.mdl") || cs_get_user_shield(id)) // Not a knife or with shield
		return PLUGIN_CONTINUE		
	
	set_pev(id, pev_viewmodel, engfunc(EngFunc_AllocString, "models/v_crowbar.mdl"))
	set_pev(id, pev_weaponmodel, engfunc(EngFunc_AllocString, "models/p_crowbar.mdl"))
	
	return PLUGIN_CONTINUE
}//----------------------------------------------------------------------------------------------
public removeCrowbar(id) {
	new szWeapon[128]
	pev(id, pev_viewmodel2, szWeapon, charsmax(szWeapon)) 
	if (!equali(szWeapon, "models/v_crowbar.mdl")) // Not a crowbar
		return PLUGIN_CONTINUE

	set_pev(id, pev_viewmodel, engfunc(EngFunc_AllocString, "models/v_knife.mdl"))
	set_pev(id, pev_weaponmodel, engfunc(EngFunc_AllocString, "models/p_knife.mdl"))
	
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public fw_emitsound(id, channel, sample[], Float:volume, Float:attenuation, fFlags, pitch) {
	if ( !is_user_connected(id) )
		return FMRES_IGNORED
	
	if ( !gHasFreemanPower[id] )
		return FMRES_IGNORED
	
	new szWeapon[128]
	pev(id, pev_viewmodel2, szWeapon, charsmax(szWeapon))
	if (!equali(szWeapon, "models/v_crowbar.mdl")) // Not a crowbar
		return PLUGIN_CONTINUE
		
	if ( equal(sample, "weapons/knife_slash1.wav") )
	{ 
		emit_sound(id, channel, "weapons/cbar_miss1.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}
	
	if ( equal(sample, "weapons/knife_slash2.wav") ) {
		emit_sound(id, channel, "weapons/cbar_miss1.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}

	if ( equal(sample, "weapons/knife_hitwall1.wav") ) {
		emit_sound(id, channel, "weapons/cbar_hit1.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}

	if ( equal(sample, "weapons/knife_hit1.wav") ) {
		emit_sound(id, channel, "weapons/cbar_hitbod1.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}
	
	if ( equal(sample, "weapons/knife_hit2.wav") ) {
		emit_sound(id, channel, "weapons/cbar_hitbod2.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}
	
	if ( equal(sample, "weapons/knife_hit3.wav") ) {
		emit_sound(id, channel, "weapons/cbar_hitbod3.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}
	
	if ( equal(sample, "weapons/knife_hit4.wav") ) {
		emit_sound(id, channel, "weapons/cbar_hitbod2.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}
	
	if ( equal(sample, "weapons/knife_stab.wav") ) {
		emit_sound(id, channel, "weapons/cbar_hitbod1.wav", volume, attenuation, fFlags, pitch)
		return FMRES_SUPERCEDE
	}
	
	return FMRES_IGNORED
}
//----------------------------------------------------------------------------------------------
// CreateMultiForward check for another hero to see if user has the hero
public sh_has_crowbar(id)
{
    if ( gHasFreemanPower[id] )
        return 4

    return 3
}
//---------------------------------------------------------------------------------------------- 
