// THE TICK! - from The Tick, The big blue arachnid who is nigh invunerable.
// Based on v3x's "No fall damage" 0.2, off of leakgfhp's method.

/* CVARS - copy and paste to shconfig.cfg

//The Tick
thetick_level 0

*/

/*
* v1.3 - vittu - 8/18/08
*       - Improved no fall damage method based on suggestion by Guilty Spark.
*       - Updated to be SH 1.2.0 compliant.
*
* v1.2 - vittu - 7/19/06
*       - Converted to fakemeta.
*
* v1.1 - vittu - 3/31/06
*       - Small code changes.
*
*/

#include <superheromod>

// GLOBAL VARIABLES
new HeroID
new bool:HasTheTick[SH_MAXSLOTS+1]
new bool:isCzero
new bool:czBotRegisterHam
new serversMaxPlayers
new bot_quota
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO The Tick", "1.3", "vittu")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	new pcvarLevel = register_cvar("thetick_level", "0")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	HeroID = sh_create_hero("The Tick", pcvarLevel)
	sh_set_hero_info(HeroID, "No Fall Damage", "SPOOOON! Take no damage from falling")

	RegisterHam(Ham_TakeDamage, "player", "ham_TakeDamage")

	serversMaxPlayers = get_maxplayers()
	bot_quota = get_cvar_pointer("bot_quota")

	new mod_name[6]
	get_modname(mod_name, 5)
	isCzero = equal(mod_name, "czero", 5) ? true : false
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	if ( HeroID != heroID ) return

	HasTheTick[id] = mode ? true : false
}
//----------------------------------------------------------------------------------------------
public ham_TakeDamage(this, inflictor, attacker, Float:damage, damagebits)
{
	if ( !sh_is_active() ) return HAM_IGNORED

	if ( damagebits & DMG_FALL && HasTheTick[this] ) return HAM_SUPERCEDE

	return HAM_IGNORED
}
//----------------------------------------------------------------------------------------------
public client_putinserver(id)
{
	if ( id < 1 || id > serversMaxPlayers ) return

	if ( isCzero && !czBotRegisterHam ) {
		// Delay for private data to initialize
		set_task(0.1, "czbotHookHam", id)
	}
}
//----------------------------------------------------------------------------------------------
public czbotHookHam(id)
{
	// Thx to Avalanche and GunGame for this setup.
	if ( czBotRegisterHam || !is_user_connected(id) ) return

	// Make sure it's a bot, and if quota greater than 0 it's a cz bot.
	if ( pev(id, pev_flags) & FL_FAKECLIENT && get_pcvar_num(bot_quota) > 0)
	{
		// CZ bots do not register with their player classname so force them to
		RegisterHamFromEntity(Ham_TakeDamage, id, "ham_TakeDamage")

		czBotRegisterHam = true
	}
}
//----------------------------------------------------------------------------------------------